'*******************************************************************************
'                 Fensterheber Komfortmodul fr Version 2.1
'
' Marcus Pool
'
' Version: 2.1
'
' geschrieben am 12.07.2004
' gendert am 06.03.2006
'  - Pull ups aus und etwas aufgerumt  
'
' Fenter auf links  = PB 7 - Pin 19
'            rechts = PB 5 - Pin 17
' Fenter zu  links  = PB 6 - Pin 18
'            rechts = PB 4 - Pin 16
'
' Zuendung          = PD 0 - Pin  2
'
' alle low aktive
'
' Relais rechts hoch   = PD 6 - Pin 11
'               runter = PD 5 - Pin 9
'        links  hoch   = PD 4 - Pin 8
'               runter = PB 0 - Pin 12
'
' Normale   Links  STOP = PD 2 = Pin 6
'           Rechts STOP = PD 3 = Pin 7
'
' Zuendung              = Nur wenn Zuendung an ist, kann alles laufen.
'*******************************************************************************

$regfile = "2313def.DAT"
'$regfile = "attiny2313.DAT"        'pin kompatibel zum AT90S2313
$crystal = 4000000

Config Pind.2 = Input                                       'berstrom
Config Pind.3 = Input                                       'berstrom

Config Timer0 = Timer , Prescale = 1024
'Konfiguriere den Timer0 als Timer mit fosc / 1024

Dim Testint As Bit

Dim Links As Byte                                           'Zhler fr Selbstlauf
Dim Rechts As Byte                                          'Zhler fr Selbstlauf

Dim B_links_zu As Bit                                       'Selbstlauf links zu
Dim B_links_auf As Bit                                      'Selbstlauf links auf
Dim B_rechts_zu As Bit                                      'Selbstlauf rechts zu
Dim B_rechts_auf As Bit                                     'Selbstlauf rechts auf

Dim Stop_r_hoch As Bit                                      'Erkennung des stopmodus
Dim Stop_r_runter As Bit                                    'Erkennung des stopmodus
Dim Stop_l_hoch As Bit                                      'Erkennung des stopmodus
Dim Stop_l_runter As Bit                                    'Erkennung des stopmodus
Dim Stop_links As Bit
Dim Stop_rechts As Bit
Dim Rechts_help As Bit
Dim Links_help As Bit

Links_help = 0 : Rechts_help = 0
B_links_zu = 0 : B_links_auf = 0
B_rechts_zu = 0 : B_rechts_auf = 0
Links = 0 : Rechts = 0
Stop_r_runter = 0 : Stop_r_hoch = 0
Stop_l_runter = 0 : Stop_l_hoch = 0

Config Watchdog = 128                                       'reset nach 128 mSec
Start Watchdog

On Ovf0 Tim0_isr                                            'Timer an

Config Pinb.0 = Output                                      'output B0
   Lr_runter Alias Portb.0
Config Pind.4 = Output                                      'output D4
   Lr_hoch Alias Portd.4
Config Pind.5 = Output                                      'output D5
   Rr_runter Alias Portd.5
Config Pind.6 = Output                                      'output D6
   Rr_hoch Alias Portd.6

Config Pinb.7 = Input                                       'auf Links B7
   Auf_l Alias Pinb.7
Config Pinb.6 = Input                                       'zu Links B6
   Zu_l Alias Pinb.6
Config Pinb.5 = Input                                       'auf Rechts B5
   Auf_r Alias Pinb.5
Config Pinb.4 = Input                                       'zu rechts B4
   Zu_r Alias Pinb.4

Config Pind.0 = Input
   Zuendung Alias Pind.0

'*******************************************************************************
' Main Programm
'*******************************************************************************

Enable Interrupts                                           'enable the interrupts
Enable Timer0                                               'enable the timer interrupt

   Reset Rr_hoch                                            'Motor Stop
   Reset Rr_runter                                          'Motor Stop
   Reset Lr_hoch                                            'Motor Stop
   Reset Lr_runter                                          'Motor Stop

Anfang:
   Idle
   If Testint = 1 Then
      Gosub Testroutine
   End If
Goto Anfang

'*******************************************************************************
' Interrupt Routinen fr berstrom
'*******************************************************************************

Links_stop:                                                 'Linken Motor stoppen bei berstrom
   Reset Lr_hoch
   Reset Lr_runter
   B_links_auf = 0
   B_links_zu = 0
   Links = 0
Return

Rechts_stop:                                                'Rechten Motor stoppen bei berstrom
   Reset Rr_hoch
   Reset Rr_runter
   B_rechts_auf = 0
   B_rechts_zu = 0
   Rechts = 0
Return

'*******************************************************************************
' Timer Interrupt Routine
'*******************************************************************************

Tim0_isr:                                                   'Ein Durchlauf ergibt ca. 65ms
   Reset Watchdog
   Testint = 1
Return

'*******************************************************************************
' Routine wird nach dem Timer Interrupt ausgefhrt
'*******************************************************************************

Testroutine:

Testint = 0                                                 'Variable fr Tastenabfrageschleife

If Zuendung = 1 Then                                        'nur laufen lassen wenn Zndung an ist
   If Rechts_help = 1 Then                                  'kein klackern bei nicht Selbstlauf
      If Pind.2 = 1 Then                                    'berstromabschaltung
         Gosub Rechts_stop
         Set Stop_rechts
         Rechts_help = 0
         Return
      End If
   End If

   If Links_help = 1 Then                                   'kein klackern bei nicht Selbstlauf
      If Pind.3 = 1 Then                                    'berstromabschaltung
         Gosub Links_stop
         Set Stop_links
         Links_help = 0
         Return
      End If
   End If

   If B_rechts_zu = 1 Then
      If Auf_r = 1 Then
         Set Stop_r_hoch
         Reset B_rechts_zu
         Reset Rr_hoch
      End If
      If Rechts = 0 Then
         If Zu_r = 1 Then
            Set Stop_r_runter
            Reset B_rechts_zu
            Reset Rr_hoch
         End If
      End If
   End If

   If Stop_r_hoch = 1 Then
      If Auf_r = 1 Then
         Goto Linke_seite
      Else
         Stop_r_hoch = 0
      End If
   End If

'***************
   If B_rechts_auf = 0 Then
      If Auf_r = 1 Then
            If B_rechts_zu = 1 Then
               B_rechts_zu = 0
               Rechts = 0
               Reset Rr_hoch
            End If
         Rechts = Rechts + 1
            If Rechts > 4 Then
               B_rechts_auf = 1
               Rechts_help = 1
            End If
         Set Rr_runter
         Waitms 100
      Else
         If B_rechts_auf <> 1 Then
            Reset Rr_runter
         End If
      End If
   Else
      If Zu_r = 1 Then
         Set Stop_r_runter
         Reset B_rechts_auf
         Reset Rr_runter
      End If
      If Rechts = 0 Then
         If Auf_r = 1 Then
            Set Stop_r_hoch
            Reset B_rechts_auf
            Reset Rr_runter
         End If
      End If
   End If

'***************
   If Stop_r_runter = 1 Then
      If Zu_r = 1 Then
         Goto Linke_seite
      Else
         Stop_r_runter = 0
      End If
   End If

'***************
   If B_rechts_zu = 0 Then
      If Zu_r = 1 Then
            If B_rechts_auf = 1 Then
               B_rechts_auf = 0
               Rechts = 0
               Reset Rr_runter
            End If
         Rechts = Rechts + 1
            If Rechts > 4 Then
               B_rechts_zu = 1
               Rechts_help = 1
            End If
         Set Rr_hoch
         Waitms 100
      Else
         If B_rechts_zu = 0 Then
            Reset Rr_hoch
         End If
      End If
   End If

'***************
   If Auf_r = 0 Then
      If Zu_r = 0 Then
         Rechts = 0
      End If
   End If

   If Zu_r = 0 Then
      If Auf_r = 0 Then
         Rechts = 0
      End If
   End If

'*********************************************
'*********************************************
                  Linke_seite:
'*********************************************
'*********************************************
   If B_links_zu = 1 Then
      If Auf_l = 1 Then
         Set Stop_l_hoch
         Reset B_links_zu
         Reset Lr_hoch
      End If
      If Links = 0 Then
         If Zu_l = 1 Then
            Set Stop_l_runter
            Reset B_links_zu
            Reset Lr_hoch
         End If
      End If
   End If

   If Stop_l_hoch = 1 Then
      If Auf_l = 1 Then
         Return
      Else
         Stop_l_hoch = 0
      End If
   End If

'***************
   If B_links_auf = 0 Then
      If Auf_l = 1 Then
            If B_links_zu = 1 Then
               B_links_zu = 0
               Links = 0
               Reset Lr_hoch
            End If
         Links = Links + 1
            If Links > 4 Then
               B_links_auf = 1
               Links_help = 1
            End If
         Set Lr_runter
         Waitms 100
      Else
         If B_links_auf <> 1 Then
            Reset Lr_runter
         End If
      End If
   Else
      If Zu_l = 1 Then
         Set Stop_l_runter
         Reset B_links_auf
         Reset Lr_runter
      End If
      If Links = 0 Then
      If Auf_l = 1 Then
            Set Stop_l_hoch
            Reset B_links_auf
            Reset Lr_runter
         End If
      End If
   End If

'***************
   If Stop_l_runter = 1 Then
      If Zu_l = 1 Then
         Return
      Else
         Stop_l_runter = 0
      End If
   End If

'***************
   If B_links_zu = 0 Then
      If Zu_l = 1 Then
            If B_links_auf = 1 Then
               B_links_auf = 0
               Links = 0
               Reset Lr_runter
            End If
         Links = Links + 1
            If Links > 4 Then
               B_links_zu = 1
               Links_help = 1
            End If
         Set Lr_hoch
         Waitms 100
      Else
         If B_links_zu = 0 Then
            Reset Lr_hoch
         End If
      End If
   End If

'***************
   If Auf_l = 0 Then
      If Zu_l = 0 Then
         Links = 0
      End If
   End If

   If Zu_l = 0 Then
      If Auf_l = 0 Then
         Links = 0
      End If
   End If
End If
Return